#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
//#include <cmath>
//#include <queue>
//#include <set>
//#include <map>
#include <algorithm>
#include <iostream>
//#include <cstdio>
//#include <sstream>
//#include <cassert>
//#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

FILE *f = 0;
int tst = 0;

void close() {
	if (f != 0) {
	   	fclose(f);
   		f = 0;
	}
}

FILE *open() {
	close();
	char fname[10];
	sprintf(fname, "%.2d", ++tst);
	return f = fopen(fname, "wt");
}

int random(int value)
{
	return ((((unsigned int)rand()) << 15) ^ ((unsigned int)rand())) % value;
}

void outdata() {
}

void solve() {
}

void eqHolidays(int n) {
	open();
	fprintf(f, "%d %d\n", n, random(n) + 1);
	vector< pair<int, int> > hol;
	int l, r, W;
	int kr = min(n, 100000 / n);
	W = max(2, 100000 / (3 * kr));
	l = random(W) + 100;
	r = l + random(W);
	forn(i, kr) {
		hol.pb( mp(l, r) );
		l = r + random(W) + 1;
		r = l + random(W) + 5;
	}
	forn(q, n) {
		random_shuffle(all(hol));
		fprintf(f, "%d", hol.size());
		forv(i, hol) {
			fprintf(f, " %d %d", hol[i].first, hol[i].second);
		}
		fprintf(f, "\n");
	}

}

void shift1Holidays(int n) {
	open();
	fprintf(f, "%d %d\n", n, random(n) + 1);
	vector< pair<int, int> > hol;
	int l, r, W;
	int kr = min(n, 100000 / n);
	W = max(2, 100000 / (3 * kr));
	l = random(W) + 100;
	r = l + random(W);
	forn(i, kr) {
		hol.pb( mp(l, r) );
		l = r + random(W) + 1;
		r = l + random(W) + 5;
	}
	int mod = 100000 - r + 1;
	forn(q, n) {
		random_shuffle(all(hol));
		fprintf(f, "%d", hol.size());
		forv(i, hol) {
			fprintf(f, " %d %d", hol[i].first + q % mod, hol[i].second + q % mod);
		}
		fprintf(f, "\n");
	}

}

void SmallShiftHolidays(int n) {
	open();
	fprintf(f, "%d %d\n", n, random(n) + 1);
	vector< pair<int, int> > hol;
	int l, r, add, W;
	int kr = min(n, 100000 / n);
	W = max(2, 100000 / (3 * kr));
	l = random(W) + 100;
	r = l + random(W);
	add = l - 2;
	forn(i, kr) {
		add = min(add, r - l + 1);
		hol.pb( mp(l, r) );
		add = min(add, 100000 - r - 2);
		l = r + random(W) + 1;
		r = l + random(W) + 5;
	}
	vector<int> w(n);
	forn(q, n) w[q] = random(add);
	random_shuffle(all(w));
	forn(q, n) {
		int t = w[q];
		if (random(2)) t = -t;
		random_shuffle(all(hol));
		fprintf(f, "%d", hol.size());
		forv(i, hol) {
			fprintf(f, " %d %d", hol[i].first + t, hol[i].second + t);
		}
		fprintf(f, "\n");
	}

}

void testLR(int n, int l, int r) {
	open();
	fprintf(f, "%d %d\n", n, n - 5);
	fprintf(f, "%d %d %d %d %d\n", 2, 1, l - 1, r + 1, 100000);
	forn(i, n - 1) {
		fprintf(f, "%d %d %d\n", 1, l, l + i);
	}
}

void readdata() {
	open();
	fprintf(f, "2 1\n2 1 3 5 10\n1 4 4\n");
	open();
	fprintf(f, "3 1\n1 1 1\n2 1 2 5 7\n1 2 10\n");
	eqHolidays(5);	eqHolidays(305);	eqHolidays(1003);
	eqHolidays(90000);	eqHolidays(95000);	eqHolidays(100000);
	shift1Holidays(5);	shift1Holidays(305);	shift1Holidays(1005);
	shift1Holidays(90000);	shift1Holidays(95000);	shift1Holidays(100000);
}

int main() 
{
	srand(892);
	readdata();
	solve();
	outdata();
	return 0;
}
