#define _CRT_SECURE_NO_WARNINGS

#include <string>
#include <vector>
#include <cmath>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <sstream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define EPS 1E-8

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forv(i, a) for (int i = 0; i < int(a.size()); i++)
#define fors(i, a) for (int i = 0; i < int(a.length()); i++)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define norm(a) sort(all(a)); a.erase(unique(all(a)), a.end());
#define num(a, v) (int)(lower_bound(all(a), v) - a.begin())

#define C_IN_FILE "holidays.in"
#define C_OUT_FILE "holidays.out"

typedef pair<int, int> segment;
#define l first
#define r second

typedef long long int64;

const int NMAX = 210000;
const int list = 1 << 18;

int n, k;
vector<segment> alh;
vector<segment> h[NMAX];
int64 tree[list << 1];
int z[NMAX];

int64 ans;
int anum;

bool cross(segment a, segment b) {
	int l, r;
	l = max(a.l, b.l);
	r = min(a.r, b.r);
	return l <= r;
}


void outdata() {
	cout << anum << endl;
}

int64 getSum(int l, int r) {
	l += list;
	r += list;
	int64 ans = 0;
	while (l <= r) {
		if (l & 1) ans += tree[l];
		if ((r & 1) == 0) ans += tree[r];
		l = (l + 1) >> 1;
		r = (r - 1) >> 1;
	}
	return ans;
}

void solve() {
	memset(tree, 0, sizeof tree);
	memset(z, 0, sizeof z);
	forv(i, alh) {
		z[alh[i].l]++;
		z[alh[i].r + 1]--;
	}
	int cs = 0;
    for(int i = 1; i <= 100000; ++i) {
    	cs += z[i];
    	int t = cs;
    	if (t > k) t = 10 * k;
    	tree[list + i] = t;
    }
    for(int i = list - 1; i > 0; --i) {
    	tree[i] = tree[i << 1] + tree[(i << 1) | 1];
    }
    int64 sum = getSum(0, 100000);
    ans = sum + 1;
    anum = -1;
    forn(i, n) {
    	int64 cres = sum;
		forv(j, h[i]) {
			cres -= getSum(h[i][j].l, h[i][j].r);
		}
		//cerr << i + 1 << " " << cres << endl;
		if (ans > cres) {
			ans = cres;
			anum = i + 1;
		}
    }
}

void readdata() {
	assert(scanf("%d%d", &n, &k) == 2);
	assert(1 <= n && n <= 100000);
	assert(1 <= k && k <= 100000);
	int sum = 0;
	forn(i, n) {
		int p;
		assert(scanf("%d", &p) == 1);
		sum += p;
		assert(1 <= p && p <= 100000);
		forn(j, p) {
			int l, r;
			assert(scanf("%d%d", &l, &r) == 2);
			assert(1 <= l && l <= r && r <= 100000);
			segment s(l, r);
			h[i].pb(s);
			alh.pb(s);
		}
		sort(all(h[i]));
		for(size_t j = 1; j < h[i].size(); ++j) {
			assert(!cross(h[i][j - 1], h[i][j]));
		}
	}
	assert(1 <= sum && sum <= 100000);
	sort(all(alh));
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}
